#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdlib.h>


void zapni_led(unsigned char i);
void zhasni_led(unsigned char index);
void efekt(unsigned char num);
void efekt1(void);
void efekt2(void);
void efekt3(void);
void efekt4(void);
void efekt5(void);
void zapni_all(void);
void zhasni_all(void);

const unsigned char DATA_C[13] = {  1,  2,  4,  8, 16, 32,  0,  0,  0,  0,  0,  0,  0 },
                    DATA_D[13] = {  0,  0,  0,  0,  0,  0,  1,  2,  4,  8, 16, 32,  0 },
                    DATA_B[13] = {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1 };
volatile unsigned char counter=0, num=0;



int main(void)
{

DDRB = 0x01;
DDRC = 0xFF;
DDRD = 0xFF;

PORTC = 0x00;
PORTD = 0x00;
PORTB = 0x00;

  // Prescaler = FCPU/1024
   TCCR0|=(1<<CS02)|(1<<CS00);
 //Enable Overflow Interrupt Enable
   TIMSK|=(1<<TOIE0);
 //Initialize Counter
   TCNT0=0;

sei();

	while(1)
	{
	   switch(num)
	           {
	            case 0: efekt1(); break;
	            case 1: efekt2(); break;
	            case 2: efekt3(); break;
	            case 3: efekt4(); break;
	            case 4: efekt5(); break;
	            }    
	}

return 0;
}


// efekt had
void efekt1(void)
{
unsigned char i;
unsigned char m=0;

	
		for(i=0; i<13; i++)
		{
		zapni_led(i);
		
		if (i<2) {m=11+i;}
		else {m=i-2;}
		zhasni_led(m);

		_delay_ms(50);
		}

}

//efekt zapni/vypni
void efekt2(void)
{
	
	zapni_all();
	_delay_ms(1000);
	zhasni_all();
	_delay_ms(500);
			
}


// efekt nahodne rozsvecovanie
void efekt3(void)
{

const unsigned char nahodne[13] = {2,4,9,8,7,12,1,10,0,5,11,3,6};
unsigned char cislo=0;


	for(cislo=0;cislo<13;cislo++)
	{
	_delay_ms(300);

	zapni_led(nahodne[cislo]);
	}

	_delay_ms(1000);
	zhasni_all();
			
}


// efekt odspodu hore
void efekt4(void)
{

unsigned char cislo=0;

	_delay_ms(300);
	zapni_led(12);
			

		for(cislo=0;cislo<6;cislo++)
		{
		_delay_ms(300);
		zapni_led(cislo);
		zapni_led(11-cislo);
		}
			
	_delay_ms(1500);
	zhasni_all();
		

}


// pulzujuci efekt (PWM)
void efekt5(void)
{

unsigned char i=1;
unsigned char pwm=1, priznak=0;
unsigned short int  pwm_doba=0;

	while(pwm>0)
	{
	
	pwm_doba=0;
		
		// urcuje kolko krat ma zostat urcita uroven PWM
		while(pwm_doba<400){

				
					// riadenie pomeru zapnute/vypnute
					for(i=0;i<16;i++)
					{
					if(i<pwm) {zapni_all();}
					else {zhasni_all();}
					}

				pwm_doba++;
				}
	
	// priznak ci ide o plynule zhasinanie alebo rozsvecovanie
	// 1 - zhasinanie, 0 - rozsvecovanie 
	if(pwm==16) {priznak=1;}


	if(priznak==0) {pwm++;}
	if(priznak==1) {pwm--;}

	
	}//while(1)
}


void zapni_led(unsigned char index)
{
   PORTB |= DATA_B[index];
   PORTC |= DATA_C[index];
   PORTD |= DATA_D[index];
}


void zhasni_led(unsigned char index)
{



   PORTB &= ~DATA_B[index];
   PORTC &= ~DATA_C[index];
   PORTD &= ~DATA_D[index];
}

void zapni_all(void)
{
	PORTC = 0xFF;
	PORTD = 0xFF;
	PORTB = 0x01;
}

void zhasni_all(void)
{

	PORTC = 0x00;
	PORTD = 0x00;
	PORTB = 0x00;

}

// pretecenie asovaa 
ISR(TIMER0_OVF_vect)
{

counter++;

	if(counter==80)
	{
	counter=0;
	num++;
	if(num>=5) num=0;
	}
}
